using System;
using System.Collections.Generic;
using MediatR;
using Sledgemapper.Shared.Entities;

namespace Sledgemapper.Api.Commands
{
    public class GetCampaignMapsCommand : IRequest<List<Session>>
    {
        public double Timestamp { get; private set; }
        public Guid CampaignId { get; private set; }
        public string UserId { get; private set; }

        public GetCampaignMapsCommand(Guid campaignId, string userId)
        {
            Timestamp = DateTimeOffset.Now.ToUnixTimeMilliseconds();
            CampaignId = campaignId;
            UserId = userId;
        }
    }
}