using System;
using MediatR;

namespace Sledgemapper.Api.Commands
{
    public class InvitePlayerToCampaignCommand : IRequest<bool>
    {
        public double Timestamp { get; private set; }
        public string CampaignName { get; private set; }
        public string Email { get; private set; }
        public string UserId { get; private set; }
        public InvitePlayerToCampaignCommand(string campaingName, string email, string userId)
        {
            Timestamp = DateTimeOffset.Now.ToUnixTimeMilliseconds();
            CampaignName = campaingName;
            UserId = userId;
            Email = email;
        }
    }

}