using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using Microsoft.EntityFrameworkCore;
using Sledgemapper.Api.Models;

namespace Sledgemapper.Api.Core.Entities
{
    [Index(nameof(CampaignName), nameof(OwnerId), IsUnique = true)]
    public class Campaign
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public Guid CampaignId { get; set; }

        public string CampaignName { get; set; }

        public string OwnerId { get; set; }

        public User Owner { get; set; }

        public ICollection<User> InvitedUsers { get; set; }

        public ICollection<Session> Maps { get; set; }
    }
}
