using Microsoft.EntityFrameworkCore;
using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Sledgemapper.Api.Core.Entities
{
    [Index(nameof(CampaignId), nameof(SessionName), IsUnique = true)]
    public class Session
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [Key]
        public Guid SessionId { get; set; }

        [Required]
        public Guid CampaignId { get; set; }

        [Required]
        public string SessionName { get; set; }

        [Required]
        public string OwnerUserId { get; set; }
    }
}
