using MediatR;
using Microsoft.AspNetCore.SignalR;
using Sledgemapper.Shared.Clients;
using System.Threading;
using System.Threading.Tasks;
using Sledgemapper.Api.Hubs;
using Sledgemapper.Api.Notifications;

namespace Sledgemapper.Api.Handlers
{
    public class SendDeleteNoteMessage : INotificationHandler<DeleteNoteNotification>
    {
        private readonly IHubContext<SledgemapperHub, ISledgemapperClient> _hub;

        public SendDeleteNoteMessage(IHubContext<SledgemapperHub, ISledgemapperClient> hub) => _hub = hub;

        public async Task Handle(DeleteNoteNotification notification, CancellationToken cancellationToken)
        {
            await _hub.Clients.Groups(notification.Session.SessionId.ToString()).DeleteNote(notification.Note);
        }
    }
}
