using MediatR;
using Microsoft.AspNetCore.SignalR;
using Sledgemapper.Api.Notifications;
using System.Threading;
using System.Threading.Tasks;
using Sledgemapper.Api.Hubs;
using Sledgemapper.Shared.Clients;

namespace Sledgemapper.Api.Handlers
{
    public class SendDeleteWallMessage : INotificationHandler<DeleteWallNotification>
    {
        private readonly IHubContext<SledgemapperHub, ISledgemapperClient> _hub;

        public SendDeleteWallMessage(IHubContext<SledgemapperHub, ISledgemapperClient> hub) => _hub = hub;

        public async Task Handle(DeleteWallNotification notification, CancellationToken cancellationToken)
        {
            await _hub.Clients.Groups(notification.Session.SessionId.ToString()).DeleteWall(notification.Wall);
        }
    }
}
