using MediatR;
using System;
using Sledgemapper.Api.Core.Entities;

namespace Sledgemapper.Api.Notifications
{
    public abstract class BaseNotification : INotification
    {
        public double Timestamp { get; private set; }
        public string UserId { get; private set; }
        public int SessionId { get; set; }
        public Session Session { get; set; }

        public BaseNotification(Session session, string userId)
        {
            Timestamp = DateTimeOffset.Now.ToUnixTimeMilliseconds();
            Session = session; ;
            UserId = userId;
        }
    }
}
